image: alpine:latest
variables:
  ANALYZERS_URL: "https://gitlab.com/gitlab-org/security-products/analyzers"

include:
  - template: Security/Dependency-Scanning.gitlab-ci.yml

container-scanning:
  script:
    - wget -O "${CI_JOB_NAME}.json" "${ANALYZERS_URL}/container-scanning/-/raw/master/spec/fixtures/report.json"
  artifacts:
    reports:
      container_scanning: "${CI_JOB_NAME}.json"

cluster-image-scanning:
  script:
    - wget -O "${CI_JOB_NAME}.json" "https://gitlab.com/gitlab-org/gitlab/-/raw/master/ee/spec/fixtures/security_reports/master/gl-cluster-image-scanning-report.json"
  artifacts:
    reports:
      cluster_image_scanning: "${CI_JOB_NAME}.json"

dast:
  script:
    - wget -O "${CI_JOB_NAME}.json" https://gitlab.com/gitlab-org/security-products/dast/-/raw/main/test/end-to-end/expect/test_baseline_api_scan.json
  artifacts:
    reports:
      dast: "${CI_JOB_NAME}.json"

dast-with-details:
  script:
    - echo NOOP
  artifacts:
    reports:
      dast: samples/dast-with-details.json

.license-scanning:
  script:
    - wget -O "${CI_JOB_NAME}.json" "${ANALYZERS_URL}/license-finder/-/raw/main/spec/fixtures/expected/${REPORT_NAME}"
  artifacts:
    reports:
      license_scanning: "${CI_JOB_NAME}.json"

license-scanning-c:
  extends: .license-scanning
  variables:
    REPORT_NAME: c/conan/v2.1.json

license-scanning-go:
  extends: .license-scanning
  variables:
    REPORT_NAME: go/modules/v2.1.json

.sast:
  variables:
    REPORT_NAME: gl-sast-report.json
  script:
    - wget -O "${CI_JOB_NAME}.json" "${ANALYZERS_URL}/${ANALYZER_NAME}/-/raw/master/test/expect/${REPORT_NAME}"
  artifacts:
    reports:
      sast: "${CI_JOB_NAME}.json"

secrets:
  variables:
    REPORT_NAME: gl-secret-detection-report-no-git.json
  script:
    - wget -O "${CI_JOB_NAME}.json" "${ANALYZERS_URL}/secrets/-/raw/master/testdata/expect/${REPORT_NAME}"
  artifacts:
    reports:
      secret_detection: "${CI_JOB_NAME}.json"

# TODO: bandit, flawfinder, phpcs-security-audit, security-code-scan, nodejs-scan, gosec

sast-eslint:
  extends: .sast
  script:
    - wget -O "${CI_JOB_NAME}.json" "${ANALYZERS_URL}/eslint/-/raw/master/qa/expect/js/gl-sast-report.json"

sast-pmd-apex:
  extends: .sast
  script:
    - wget -O "${CI_JOB_NAME}.json" "${ANALYZERS_URL}/pmd-apex/-/raw/master/qa/expect/apex-salesforce/gl-sast-report.json"

sast-sobelow:
  extends: .sast
  variables:
    ANALYZER_NAME: sobelow

sast-spotbugs:
  extends: .sast
  variables:
    ANALYZER_NAME: spotbugs

sast-tslint:
  extends: .sast
  variables:
    ANALYZER_NAME: tslint

coverage_fuzzing:
  script:
    - wget -O "${CI_JOB_NAME}.json" https://gitlab.com/gitlab-org/security-products/demos/coverage-fuzzing/c-cpp-fuzzing-example/-/raw/master/gl-coverage-fuzzing-report-example.json
  artifacts:
    reports:
      coverage_fuzzing: "${CI_JOB_NAME}.json"

api_fuzzing:
  script:
    - wget -O "${CI_JOB_NAME}.json" "${ANALYZERS_URL}/api-fuzzing/-/raw/master/example/reports/gl-api-fuzzing-report.json?inline=false"
  artifacts:
    reports:
      api_fuzzing: "${CI_JOB_NAME}.json"

